/// <reference types="node" />
import { EventEmitter } from 'events';
import { SlidingWindowRateLimiterBackend, SlidingWindowRateLimiterBackendOptions } from './sliding-window-rate-limiter-backend';
declare type ms = number;
declare type s = number;
interface Buckets {
    [key: string]: ms[];
}
interface Timers {
    [key: string]: NodeJS.Timer;
}
export declare type MemorySlidingWindowRateLimiterOptions = SlidingWindowRateLimiterBackendOptions;
export declare class MemorySlidingWindowRateLimiter extends EventEmitter implements SlidingWindowRateLimiterBackend {
    readonly options: MemorySlidingWindowRateLimiterOptions;
    readonly interval: s;
    protected buckets: Buckets;
    protected timers: Timers;
    constructor(options?: MemorySlidingWindowRateLimiterOptions);
    check(key: string, limit: number): Promise<number>;
    reserve(key: string, limit: number): Promise<number | ms>;
    cancel(key: string, ts: number): Promise<number | ms>;
    destroy(): void;
    protected bucketExpireNow(key: string): ms;
}
export default MemorySlidingWindowRateLimiter;
