"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const memory_sliding_window_rate_limiter_1 = require("./memory-sliding-window-rate-limiter");
const redis_sliding_window_rate_limiter_1 = require("./redis-sliding-window-rate-limiter");
const safe_redis_sliding_window_rate_limiter_1 = require("./safe-redis-sliding-window-rate-limiter");
tslib_1.__exportStar(require("./memory-sliding-window-rate-limiter"), exports);
tslib_1.__exportStar(require("./redis-sliding-window-rate-limiter"), exports);
tslib_1.__exportStar(require("./safe-redis-sliding-window-rate-limiter"), exports);
var SlidingWindowRateLimiter;
(function (SlidingWindowRateLimiter) {
    function createLimiter(options = {}) {
        if (options.safe && options.redis) {
            return new safe_redis_sliding_window_rate_limiter_1.SafeRedisSlidingWindowRateLimiter(options);
        }
        else if (options.redis) {
            return new redis_sliding_window_rate_limiter_1.RedisSlidingWindowRateLimiter(options);
        }
        else {
            return new memory_sliding_window_rate_limiter_1.MemorySlidingWindowRateLimiter(options);
        }
    }
    SlidingWindowRateLimiter.createLimiter = createLimiter;
})(SlidingWindowRateLimiter = exports.SlidingWindowRateLimiter || (exports.SlidingWindowRateLimiter = {}));
exports.default = SlidingWindowRateLimiter;
